/*
 * faultInjector.cc
 * Represents a Fault Injector to simulate deterministic and 
 * random faults on the frame receptions
 *
 *  Created on: Nov 26, 2012
 *      Author: aguerreiro
 */
#include <time.h>
#include "faultInjector.h"
#include "wpan/p802_15_4trace.h"
#include <queue>


/*
 MAC_Subtype_Beacon) ? "M_BEACON"  :			//Beacon
 MAC_Subtype_Command_AssoReq) ? "M_CM1_AssoReq"  :	//CMD: Association request
 MAC_Subtype_Command_AssoRsp) ? "M_CM2_AssoRsp"  :	//CMD: Association response
 MAC_Subtype_Command_DAssNtf) ? "M_CM3_DisaNtf"  :	//CMD: Disassociation notification
 MAC_Subtype_Command_DataReq) ? "M_CM4_DataReq"  :	//CMD: Data request
 MAC_Subtype_Command_PIDCNtf) ? "M_CM5_PidCNtf"  :	//CMD: PAN ID conflict notification
 MAC_Subtype_Command_OrphNtf) ? "M_CM6_OrphNtf"  :	//CMD: Orphan notification
 MAC_Subtype_Command_BconReq) ? "M_CM7_Bcn-Req"  :	//CMD: Beacon request
 MAC_Subtype_Command_CoorRea) ? "M_CM8_CoorRal"  :	//CMD: Coordinator realignment
 MAC_Subtype_Command_GTSReq) ?  "M_CM9_GTS-Req"  :	//CMD: GTS request
 MAC_Subtype_ACK) ? "M_ACK"  :			//Acknowledgement
	  "M_UNKN"*/

char *array[] = {"M_BEACON", "M_CM1_AssoReq", "M_CM2_AssoRsp","M_CM3_DisaNtf","M_CM4_DataReq","M_CM5_PidCNtf","M_CM6_OrphNtf","M_CM7_Bcn-Req","M_CM8_CoorRal","M_CM9_GTS-Req","M_ACK","M_UNKN"};
bool activeFault=false;
int frame=0;
int nrtimes=0;
int count=0;
corruptNode currentNode;
std::queue<corruptNode> currentNodeList;


Packet* corruptFrame(Packet *p,int node) {
	if (activeFault) {
		currentNodeList.size();

		if(currentNode.nrtimes>currentNode.count && node== currentNode.nodeId){
			fprintf(stdout, "\n [%f] inside Fault Injector ...the frame to corrupt:%s \n", CURRENT_TIME,array[currentNode.frame]);
			if(strcmp(wpan_pName(p),array[currentNode.frame])==0){
				fprintf(stdout, "\n corrupting the frame=%s. on the Node:%d. \n ",wpan_pName(p),currentNode.nodeId);
				HDR_CMN(p)->error()=1;
				currentNode.count++;
			}

		}
		else{
			HDR_CMN(p)->error() = 0;
		}
	}

	return p;
}


void randomC::start(double stop,int frm,int xtimes,int node)
{
	active = true;

	currentNode=corruptNode();

	currentNode.count=0;
	currentNode.frame=frm;
	currentNode.nodeId=node;
	currentNode.nrtimes=xtimes;

	currentNodeList.push(currentNode);
	frame=frm;
	nrtimes=xtimes;
	Event *nullEvent;
	unsigned int iseed = (unsigned int)time(NULL);
	srand (iseed);


	double t =((double)rand() * ( stop - 1.0 ) ) / (double)RAND_MAX + 1.0;



	nullEvent=new Event();

	nullEvent->uid_ = 0;
	if (&nullEvent!=NULL)
		Scheduler::instance().schedule(this,nullEvent,t);


	fprintf(stdout,"\n enablefaultInjector ON NODE:%d ---AT:%f\n",currentNode.nodeId,CURRENT_TIME+nullEvent->time_);
}

void randomC::cancel(void)
{

	active = false;
	Scheduler::instance().cancel(&nullEvent);
}

void randomC::handle(Event* e)
{

	activeFault = true;


	//corruptFrame((Packet*)e);

}



void enableFaultInjector(int frm,int xtimes,int node) {
	activeFault = true;
	currentNode=corruptNode();
	currentNode.count=0;
	currentNode.frame=frm;
	currentNode.nodeId=node;
	currentNode.nrtimes=xtimes;

	fprintf(stdout,"\n enablefaultInjector ON NODE:%d ---AT:%f\n",currentNode.nodeId,CURRENT_TIME);
	currentNodeList.push(currentNode);

}

void disableFaultInejctor() {
	activeFault = false;
}

