/*
 * faultInjector.h
 * Represents a Fault Injector to simulate deterministic and 
 * random faults on the frame receptions
 *
 *  Created on: Nov 26, 2012
 *      Author: aguerreiro
 */

#ifndef FAULTINJECTOR_H_
#define FAULTINJECTOR_H_
#include "wpan/p802_15_4pkt.h"
class randomC : public Handler {
public:
	randomC() : Handler()
	{
		active=false;

	}
	virtual void start(double stop,int x,int ntimes,int node);
	virtual void cancel(void);
	virtual void handle(Event* e);

protected:

	bool active;
	Event nullEvent;


};

class corruptNode {
public:
	int nodeId;
	int frame;
	int nrtimes;
	int count;
};

/*
 MAC_Subtype_Beacon) ? "M_BEACON"  :			//Beacon
 MAC_Subtype_Command_AssoReq) ? "M_CM1_AssoReq"  :	//CMD: Association request
 MAC_Subtype_Command_AssoRsp) ? "M_CM2_AssoRsp"  :	//CMD: Association response
 MAC_Subtype_Command_DAssNtf) ? "M_CM3_DisaNtf"  :	//CMD: Disassociation notification
 MAC_Subtype_Command_DataReq) ? "M_CM4_DataReq"  :	//CMD: Data request
 MAC_Subtype_Command_PIDCNtf) ? "M_CM5_PidCNtf"  :	//CMD: PAN ID conflict notification
 MAC_Subtype_Command_OrphNtf) ? "M_CM6_OrphNtf"  :	//CMD: Orphan notification
 MAC_Subtype_Command_BconReq) ? "M_CM7_Bcn-Req"  :	//CMD: Beacon request
 MAC_Subtype_Command_CoorRea) ? "M_CM8_CoorRal"  :	//CMD: Coordinator realignment
 MAC_Subtype_Command_GTSReq) ?  "M_CM9_GTS-Req"  :	//CMD: GTS request
 MAC_Subtype_ACK) ? ","  :			//Acknowledgement
	  "M_UNKN"*/

extern bool activeFault;
extern bool faultEnable;
extern int frame;
extern 	int nrtimes;
extern int count;

Packet* corruptFrame(Packet *p,int node);


void enableFaultInjector(int x,int ntimes,int node);


void disableFaultInejctor();


#endif /* FAULTINJECTOR_H_ */

