/*
 * temporalAccount.h
 * Represents a Temporal and Energetic Account module
 * to record the time and energy of the frame receptions events
 *
 *  Created on: Dec 27, 2012
 *      Author: aguerreiro
 */

#ifndef TEMPORALACCOUNT_H_
#define TEMPORALACCOUNT_H_
#include "wpan/p802_15_4mac.h"
class temporalAccount {
public:
	int nodeId,scenario;

	double time1,time2,time3,time4,time_sbfl,time_mbfl,time_ophNode,time_ophCoord,time_cordrealignNode,time_cordrealignCoord,time_panidconflict,time_gtsReq,time_gtsAck;

	temporalAccount()
	{
		nodeId=-1;
		scenario=0;
		time1=0.0;
		time2=0.0;
		time3=0.0;
		time4=0.0;
		time_sbfl=0.0;
		time_mbfl=0.0;
		time_ophNode=0.0;
		time_ophCoord=0.0;
		time_cordrealignNode=0.0;
		time_cordrealignCoord=0.0;
		time_panidconflict=0.0;
		time_gtsReq=0.0;
		time_gtsAck=0.0;
		//count=0;
	}
};

class energyAccount {
public:
	int nodeId,scenario;

	double energy1,energy2,energy3,energy4,energy_sbfl,energy_mbfl,start,stop,energy_ophNode,energy_ophCoord,energy_cordrealignNode,energy_cordrealignCoord,energy_panidconflict,energy_gtsReq,energy_gtsAck;
	bool diff;

	energyAccount()
	{
		diff=false;
		nodeId=-1;
		scenario=0;
		energy1=0.0;
		energy2=0.0;
		energy3=0.0;
		energy4=0.0;
		energy_sbfl=0.0;
		energy_mbfl=0.0;
		energy_ophNode=0.0;
		energy_ophCoord=0.0;
		energy_cordrealignNode=0.0;
		energy_cordrealignCoord=0.0;
		energy_panidconflict=0.0;
		energy_gtsReq=0.0;
		energy_gtsAck=0.0;
		start=0.0;
		stop=0.0;

	}
};

void eventTime(UINT_8 numLostFrames,int index_,UINT_8 MSDU_CmdType,UINT_16 MHR_FrmCtrl,bool isPANCoor);

void enabletempAccount(temporalAccount tx);

void eventEnergy(UINT_8 numLostBeacons,int index_,double energy,UINT_8 MSDU_CmdType,UINT_16 MHR_FrmCtrl,bool isPANCoor);

void enableEnergyAccount(energyAccount tx);

#endif /* TEMPORALACCOUNT_H_ */

